# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $

package ESP::SMS::Plugin::search;

use strict;
our $VERSION = '0.01';

use ESP::SMS::Plugin;

# 例1
# ESP::SMS::Pages::Users::SearchにESP::SMS::Plugin::Samples::Pagesで
# 定義したメソッドを追加する。
ESP::SMS::Plugin->append('ESP::SMS::Pages::Users::Search' => 'ESP::SMS::Plugin::Samples::Pages');

# 例2
# ESP::SMS::Pages::Users::Searchにこのファイルで定義したメソッド
# (dispatch_hello, dispatch_sample)を追加する。
ESP::SMS::Plugin->append('ESP::SMS::Pages::Users::Search' => __PACKAGE__);

# URL: http://domain/search/0/hello.html
# 使用テンプレート: なし(直接書く場合)
sub dispatch_hello {
	my $self = shift;
	$self->tmpl->file(\"<html><body>Hello, World!</body></html>");
	return;
}

# URL: http://domain/search/0/sample.html
# 使用テンプレート: local/plugins/skel/search/0/_sample.html
sub dispatch_sample {
	my $self = shift;
	$self->tmpl->param(str => 'Hello');
	return;
}

# テンプレートの記述例
# local/plugins/skel/search/0/_sample.html
#
# <html>
# <head>
# <% INCLUDE META %>
# <link href="<% URL_STATIC %>/detail.css" rel="stylesheet" type="text/css">
# <script type="text/javascript" src="<% URL_STATIC %>/js/common.js"></script>
# <title>Hello, World! - <% site_name %></title>
# </head>
# <body>
# <% INCLUDE HEADER %>
# <% INCLUDE LEFT %>
# <div id="contents">
# <div class="search">
#
# <h3><% str %>, World!</h3>
#
# </div>
# </div>
# <% INCLUDE RIGHT %>
# <% INCLUDE FOOTER %>
# </body>
# </html>

1;
__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
