/* -*- coding: utf-8-unix; indent-tabs-mode: t -*-
 *
 * Editor v1.0
 * by (C) 2009-2010 E-Shoppy Project
 * required: jQuery v1.3
 * Licensed under both MIT and GPL License
 *
 * CSS(editor.css):
 * body {
 *     background: url(img/lines.gif) repeat-y left 0px;
 *     padding: 0px 0px 0px 0px;
 *     margin: 4px 0px 0px 32px;
 *     font-size: 13px;
 *     line-height: 16px;
 *     white-space: pre;
 * }
 * pre {
 *     padding: 0px 0px 0px 0px;
 *     margin: 0px 0px 0px 0px;
 * }
 * pre br {
 *     display: block;
 * }
 * 
 * HTML:
 * <script type="text/javascript" src="/path/to/jquery.js"></script>
 * <script type="text/javascript" src="/path/to/editor.js"></script>
 * <script type="text/javascript">
 * <!--
 * $(function() {
 *    $('#editor').Editor({ css: '/path/to/editor.css' });
 * });
 * //-->
 * </script>
 * 
 * <a href="javascript:void(0);" id="editor-on">ON</a>
 * <a href="javascript:void(0);" id="editor-off">OFF</a>
 * <textarea name="message" cols="80" rows="5" id="editor"></textarea>
 * 
 */
$.fn.Editor = function(options){
	options = $.extend({ css: '' }, options);
	var cssFile = options.css;
	if (cssFile == '') alert('No defined path of the css for iframe!');
	return this.each(function(){
		var time = (new Date).getTime();
		var id = 'iframe_'+time;
		var iframe = '#'+id;
		var source = $(this);
		var source_id = source.attr('id');

		// フレーム生成
		var height = source.height();
		var width  = source.width();
		source.attr('disabled', true).after('<iframe id="'+id+'" frameborder="0"></iframe>');
		var editor = $(iframe);
		editor.css('visibility', 'hidden').css('position', 'absolute').height(height).width(width);

		// フレーム内のコンテンツ生成
		var contents = editor.contents().get(0);
		var orig = source.val();
		contents.open();
		contents.write('<html><head></head><body></body></html>');
		$(contents).find('head').append('<link type="text/css" href="'+cssFile+'?'+time+'" rel="stylesheet" />');
		$(contents).find('body').addClass(source.attr('class'));
		contents.close();

		// コンテンツを編集可能に設定
		if ($.browser.msie) { // IE
			$(contents.body).keydown(function(e){
				if (e.keyCode == 13 && !e.shiftKey){ // 改行コード
					var range =	contents.selection.createRange();
					range.pasteHTML('<br>');
					range.select();
					return false;
				}
				return true;
			}).blur(function(){ // テキストエリアに反映
				source.val($.toText($(this).html()));
			});
			source.blur(function(){
				$(contents.body).html('<pre>'+$.toHTML(source.val())+'</pre>');
			}).blur();
			contents.body.contentEditable = true;
		} else if (navigator.userAgent.indexOf('Chrome') != -1) { // Chrome
			$(contents.body).blur(function(){
				source.val($.toText($(this).html()));
			});
			source.blur(function(){
				$(contents.body).html($.toHTML(source.val()));
			}).blur();
			contents.body.contentEditable = true;
		} else {
			if ($.browser.safari) { // Safari
				$(contents).find('html').blur(function(){
					source.val($.toText($(this).find('body').html()));
				});
			} else { // Firefox, etc.
				$(contents).blur(function(){
					source.val($.toText($(this).find('body').html()));
				});
			}
			source.blur(function(){
				$(contents).find('body').html($.toHTML(source.val()));
			}).blur();
		 	contents.designMode = 'on';
		}

		// テキストエリアの代りにフレーム表示
		source.attr('disabled', false);
		editor.css('position', 'static');

		$('#'+source_id+'-on').click(function(){
			source.css('display', 'none');
			editor.css('display', 'inline').css('visibility', 'visible');
			return false;
		}).click();
		$('#'+source_id+'-off').click(function(){
			editor.css('display', 'none').css('visibility', 'hidden');
			source.css('display', 'inline');
			return false;
		});
	});
};

$.toHTML = function(text){
	text = text.replace(/&/gi, '&amp;');
	text = text.replace(/</g, '&lt;');
	text = text.replace(/>/g, '&gt;');
	text = text.replace(/\n/g, '<br>');
	return text;
};

$.toText = function(html){
	html = html.replace(/<br>/gi, '\n');
	html = html.replace(/<div>/gi, '\n'); // Safari
	html = html.replace(/<.*?>/g, '');
	html = html.replace(/&lt;/g, '<');
	html = html.replace(/&gt;/g, '>');
	html = html.replace(/&amp;/gi, '&');
	return html;
};
