/* -*- coding: utf-8-unix; indent-tabs-mode: t -*-
 *
 * (C) 2009-2012 E-Shoppy Project
 * required: jQuery v1.3
 *
 */

$.fn.Disable = function(){
	return this.each(function(){
		this.disabled = true;
	}); 
};

$.fn.Enable = function(){
	return this.each(function(){
		this.disabled = false;
	}); 
};

$.fn.Keyword = function(word){
	if (word == undefined) word = '検索キーワード';
	return this.each(function(){
		var field = this;
		$(field).focus(function(){
			if ($(this).val() == word) $(this).css('color', '#000').val('');
		}).blur(function(){
			if ($(this).val() == '') $(this).css('color', '#666').val(word);
		}).blur();
		$(field.form).submit(function(){
			if ($(field).val() == word) $(field).val('');
		});
	});
};

$.fn.StrCounter = function(options){
	return this.each(function(){
		$(this).click(function(){
			var id = $(this).attr('id').split('-');
			if (id[1] == '') return alert('No defined attribute: id="counter-***"');
			var str = $(this.form).find('input[name='+id[1]+'], textarea[name='+id[1]+']').val();
			alert('テキストは'+str.length+'文字です。');
			return false;
		});
	});
};

$.fn.Click = function(url, options){
	options = $.extend({ confirm: '', prompt_name: '', prompt_val: '' }, options);
	return this.each(function(){
		$(this).click(function(){
			if (options.confirm != '' && !confirm(options.confirm)) return false;
			if (options.prompt_name != '' || options.prompt_val != '') {
				url += prompt(options.prompt_name, options.prompt_val);
			}
			location.href = url;
			return false;
		});
	});
};

$.fn.Selection = function(options){
	options = $.extend({}, options);
	return this.each(function(){
		$(this).find('select').each(function(){
			var name = $(this).attr('name');
			if (options[name] != undefined) {
				$(this).val(options[name]);
			} else {
				options[name] = $(this).val();
			}
			$(this).change(function(){
				options[name] = $(this).val();
				var query = [];
				for (var i in options) {
					query.push(i+'='+options[i]);
				}
				location.href = this.form.action+'&'+query.join('&');
			});
		});
	});
};

$.fn.Help = function(url, options){
	return this.each(function(){
		$(this).OpenWin(url+$(this).attr('name'), 'help', options);
	});
};

$.fn.ImgClean = function(url, options){
	options = $.extend({ key: 'id', query: '' }, options);
	var key = options.key;
	var query = options.query;
	return this.each(function(){
		var name = $(this).attr('name').split(':'); // [10000, 1234-1.jpg]
		var img = name[1].split(/[-\.]/); // [1234, 1, jpg]
		$(this).Click(url+'?'+key+'='+name[0]+query, { confirm: '画像'+img[1]+'('+name[1]+')を削除しますか？' });
	});
};

function OpenWinOption(options){
	options = $.extend({ toolbar: 'no',	location: 'yes', directories: 'no',	menubar: 'no',
						 scrollbars: 'yes', resizable: 'yes', width: 520, height: 400 }, options);
	var Options = [];
	for (var i in options) {
		Options.push(i+'='+options[i]);
	}
	return Options.toString();
}
function OpenWin(url, options) {
	var win = window.open(url, 'openwin', OpenWinOption(options));
	self.name = 'mainwin';
	if (win) win.focus();
}
$.fn.OpenWin = function(url, name, options){
	var option = OpenWinOption(options);
	return this.each(function(){
		$(this).click(function(){
			var win = window.open(url, name, option);
			self.name = 'mainwin';
			if (win) win.focus();
			return false; //バブリングなし
		});
	});
};

$.fn.PostalSearch = function(url, options){
	options = $.extend({ toolbar: 'no',	location: 'yes', directories: 'no',	menubar: 'no',
						 scrollbars: 'yes', resizable: 'yes', width: 520, height: 400 }, options);
	var winOptions = [];
	for (var i in options) {
		winOptions.push(i+'='+options[i]);
	}
	self.name = 'mainwin';
	return this.each(function(){
		var form = $(this);
		form.find('.PostalSearch').each(function(){
			$(this).click(function(){
				var id = $(this).attr('id');
				var code = form.find('#'+id+'_code');
				var query = [];
				query.push('zip='+code.attr('name'));
				query.push('area='+form.find('#'+id+'_area').attr('name'));
				query.push('city='+form.find('#'+id+'_city').attr('name'));
				query.push('town='+form.find('#'+id+'_town').attr('name'));
				query.push('id='+code.val());
				var win = window.open(url+'?'+query.join('&'), 'postal', winOptions.toString());
				if (win) win.focus();
				return false;
			});
		});
	});
};

$.fn.OutputFormat = function(format, options){
	options = $.extend({ id: 'outputformat' }, options);
	var id = options.id;
	var html = '<div id="'+id+'">'+format.join("\n")+'</div>';
	return this.each(function(){
		var form = $(this);
		form.find('.OutputFormat').each(function(){
			$(this).change(function(){
				var type = $(this).val();
				var action = form.attr('action');
				var limit = form.find('select[name=li]').get(0);
				if (type != 'html') {
					$(this).parent().append(html);
					limit.disabled = true;
				} else {
					$(this).parent().find('#'+id).remove();
					limit.disabled = false;
				}
				form.attr('action', action.substr(0, action.lastIndexOf('.'))+'.'+type);
			});
		}).change();
	});
};

$.DateTime = function(style){
	var t = new Date();
	var y = t.getFullYear();
	var m = t.getMonth() + 1;
	var d = t.getDate();
	var H = t.getHours();
	var M = t.getMinutes();
	var S = t.getSeconds();
	if (m < 10) m = '0' + m;
	if (d < 10) d = '0' + d;
	if (H < 10) H = '0' + H;
	if (M < 10) M = '0' + M;
	if (S < 10) S = '0' + S;
	var str = y + '/' + m + '/' + d;
	switch(style) {
		case 1: str += ' ' + H + ':' + M; break;
		case 2: str += ' ' + H + ':' + M + ':' + S; break;
	}
	return str;
};

/*
 * パスワード作成
 *
 * 使用例:
 *
 * <script type="text/javascript">
 * <!--
 * $(function() {
 *    $('input.passgen').PassGenerator({ digit: 10 });
 * });
 * //-->
 * </script>
 *
 * <form action="/path/to" method="post">
 * パスワード1:<input type="password" name="field1" value="" size="20" maxlength="20" />
 * <input type="button" value="パスワード1作成" id="passgen-field1" class="passgen" />
 *
 * パスワード2:<input type="password" name="field2" value="" size="20" maxlength="20" />
 * <input type="button" value="パスワード2作成" id="passgen-field2" class="passgen" />
 * </form>
 *
 */
$.fn.PassGenerator = function(options){
	options = $.extend({ confirm: "次のパスワードを入力しますか？\n"+
						 "パスワードをメモしてから確認(OK)ボタンを押して下さい。",
						 chars: "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-",
						 digit: 8 }, options);
	var chars = options.chars; // 使用文字
	var D = options.digit; // パスワードの桁数
	var N = chars.length;
	return this.each(function(){
		$(this).click(function(){
			var c = [];
			for (var i = 0; i < D; i++) c.push(chars.charAt(Math.floor(Math.random() * N)));
			var passwd = prompt(options.confirm, c.join(''));
			if (passwd != null && passwd != "") {
				var id = $(this).attr('id').split('-');
				$(this.form).find('input[name='+id[1]+']').val(passwd);
			}
			return false;
		});
	});
};

/*
 * バイト数作成
 *
 * 使用例:
 *
 * <script type="text/javascript">
 * <!--
 * $(function() {
 *    $('input.mbyte').ToByte({ rate: 1024*1024, confirm: 'Mバイト数を入力して確認(OK)ボタンを押して下さい。' });
 * });
 * //-->
 * </script>
 *
 * <form action="/path/to" method="post">
 * パスワード1:<input type="text" name="field1" value="" size="20" maxlength="20" />
 * <input type="button" value="Mバイト単位で入力" id="tobyte-field1" class="mbyte" />
 *
 * パスワード2:<input type="text" name="field2" value="" size="20" maxlength="20" />
 * <input type="button" value="Mバイト単位で入力" id="tobyte-field2" class="mbyte" />
 * </form>
 *
 */
$.fn.ToByte = function(options){
	options = $.extend({ confirm: "バイト数を入力して確認(OK)ボタンを押して下さい。\n"+
						 "バイト単位に変換して入力されます。",
						 rate: 1 }, options);
	var rate = options.rate; // 換算係数
	return this.each(function(){
		$(this).click(function(){
			var id = $(this).attr('id').split('-');
			var bytes = $(this.form).find('input[name='+id[1]+']').val();
			var number = prompt(options.confirm, Math.round(bytes/rate));
			if (number != null && number != "") {
				$(this.form).find('input[name='+id[1]+']').val(Math.round(number*rate));
			}
			return false;
		});
	});
};
