/* -*- coding: utf-8-unix; indent-tabs-mode: t -*-
 *
 * (C) 2009-2010 E-Shoppy Project
 * required: jQuery v1.3, $.fn.Disable(), $.fn.Enable()
 *
 */

$.fn.FileManager = function(url_base, options){
	options = $.extend({ query: '' }, options);
	var query = options.query;
	return this.each(function(){
		return $(this).click(function(){
			var attr = $(this).attr('id').split('-');
			var mode = attr.shift();
			var id = attr.join('-');
			var suffix = '.html?';
			if (mode == 'remove') {
				if (!confirm(id+'を削除しますか？')) return false;
			} else if (mode == 'rename') {
				var to = prompt('[ファイル名の変更] 新しい名前を入力して下さい。', id);
				if (to == null) return false;
				query += '&to_filename='+to;
			} else if (mode == 'download') {
				var length = id.length;
				suffix = id.substr(length-3,3).toLowerCase();
				if ((suffix == 'gif') || (suffix == 'jpg') || (suffix == 'png')) {
					OpenWin(url_base+'/stream.'+suffix+'?'+query+'&filename='+id);
					return false;
				} else {
					suffix = '.do?';
				}
			} else if (mode == 'mkdir') {
				id = prompt('[フォルダの作成] 新しいフォルダ名を入力して下さい。');
				if (id == null) return false;
			} else if (mode == 'rmdir') {
				if (!confirm('フォルダ['+id+']を削除しますか？')) return false;
			} else if (mode == 'redir') {
				var to = prompt('[フォルダ名の変更] 新しい名前を入力して下さい。', id);
				if (to == null) return false;
				query += '&to_filename='+to;
			}
			location.href = url_base+'/'+mode+suffix+query+'&filename='+id;
			return false;
		});
	});
};

$.fn.BuildManager = function(options){
	options = $.extend({ messages: '#messages', message_stop: '実行ボタンを押して下さい。',
						 message_start: '実行しています', url: '', path: '', parent_url: '',
						 fields: [] }, options);
	var messages = options.messages;
	var message_stop = options.message_stop;
	var message_start = options.message_start;
	var url = options.url;
	var path = options.path;
	var parent_url = options.parent_url;
	var fields = options.fields;
	$(messages).val(message_stop);
	return this.each(function(){
		return $(this).click(function(){
			var form = $(this.form);
			form.find('input[type=button]').Disable();
			var query = [];
			query.push('path='+path);
			var N = fields.length;
			for (var i = 0; i < N; i++) {
				var name = fields[i].split(':');
				var selector = ['input[name='];
				selector.push(name[0]);
				selector.push(']');
				if (name[1] != undefined) selector.push(':'+name[1]);
				query.push(name[0]+'='+form.find(selector.join('')).val());
			}
			var timerID = null;
			$.ajax({
				type: 'GET',
				url: url+'?'+query.join('&'),
				async: true,
				cache: false,
				beforeSend: function(){
					var dots = ['.'];
					timerID = setInterval(function(){
						if (timerID != null) {
							dots.push('.');
							$(messages).val(message_start+dots.join(''));
						}
					}, 500); // 0.5sec
					return true;
				},
				success: function(text, status){
					$(messages).val(text);
					if (parent_url != '' && parent.opener != undefined)
						parent.opener.location.href = parent_url;
				},
				complete: function(){
					if (timerID != null) clearInterval(timerID);
					form.find('input[type=button]').Enable();
				}
			});
			return false;
		});
	});
};
